//+------------------------------------------------------------------+
//|                                              Classic ZigZag .mq4 |
//|                                 Copyright c 2008, FXIBANK & INTG |
//|                                            rone.sergey@gmail.com |
//|   max-min                  |
//|  ,     -|
//|   (    4    )|
//|  ( ).     -|
//|  ,      4.     |
//|  ?                                     |
//+------------------------------------------------------------------+
#property copyright "Copyright c 2008, FXIBANK & INTG"
#property link      "rone.sergey@gmail.com"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 White
#property indicator_width1 1

extern int               a=5;
extern int               b=21;
extern int   MODE=1;//MODE_SMA=0,MODE_EMA=1,MODE_SMMA=2,MODE_LWMA=3
extern int   PRICE=0;//PRICE_CLOSE=0,PRICE_MEDIAN=4
extern double otstup=0;
int        L,H;

double     ExtBuffer0[];
double     ExtBuffer1[];
double     priceL,priceH,min,max;

extern int BarsDepth=5000;
double ReversalPercent=0.3;
bool UseReversalPips=true;
extern bool ShowBarsCount=false;
int ReversalPips=0;
extern bool ShowPipsValue=true;
extern bool HidePippets=true;
extern int FontSize=8;
extern string FontName="Arial";
extern color FontColor=White;
extern int TextIndentUp=200;
extern int TextIndentDown=200;

double zz[];
//-----------------------------------
int deinit()
   {
   ObjectsDeleteAll(0,OBJ_TEXT);
   }
//-----------------------------------
int init()
   {
   SetIndexBuffer(0,zz);
   SetIndexBuffer(1,ExtBuffer0);
   SetIndexBuffer(2,ExtBuffer1);
   SetIndexStyle(0,DRAW_SECTION);
   }
//-----------------------------------
int start()
   { 
   double reverse, prev, dPipsValue;
   bool bUp=true;
   int last, prevLast, nBarsInZ, k;
   string sData, id;
   
   if (BarsDepth==0) BarsDepth=Bars-1;
   
   for(int l=0; l<BarsDepth; l++)
   ExtBuffer1[l]=(iMA(NULL,0,a,0,MODE,PRICE,l)-iMA(NULL,0,b,0,MODE,PRICE,l)); 
   
     
      if (ExtBuffer1[BarsDepth]<=0-NormalizeDouble(otstup*Point,Digits))
      { bUp=false;}
      
      if (ExtBuffer1[BarsDepth]>=0+NormalizeDouble(otstup*Point,Digits) )
       {bUp=true;}
       
   for (int i=BarsDepth; i>=0; i--)
   
      {
      //if (UseReversalPips) reverse=ReversalPips*Point;
      //else reverse = NormalizeDouble(ReversalPercent*Close[i]/100,Digits);
      
     
      
      //  
      if (bUp)
         {
         //   
         if (High[i]>prev)
            {
            zz[i]=High[i]; prev=High[i];
            zz[last]=EMPTY_VALUE; last=i; 
            }
         else
            {
            //   
            if (ExtBuffer1[i]<=0-NormalizeDouble(otstup*Point,Digits))
               {
               bUp=false;
               zz[i]=Low[i]; prev=Low[i];
               if (ShowPipsValue)
                  {
                  dPipsValue=(High[last]-Low[prevLast])/Point; //     
                  nBarsInZ=prevLast-last; // -   
                  if (HidePippets==true) sData=DoubleToStr(dPipsValue/10,0); else sData=DoubleToStr(dPipsValue,0);
                  if (ShowBarsCount==true) sData=StringConcatenate(sData," (",nBarsInZ,")");
                  id="exm"+prevLast;
                  //     
                  if (ObjectFind(id)==-1)
                     {
                     ObjectCreate(id,OBJ_TEXT,0,Time[last],High[last]+(TextIndentUp)*Point);
                     //ObjectSetText(id,sData,FontSize,FontName,FontColor);
                     }
                  ObjectMove(id,0,Time[last],High[last]+(TextIndentUp)*Point);
                  ObjectSetText(id,sData,FontSize,FontName,FontColor);
                  }
               prevLast=last; last=i;
               }
            //    
            else
               {
               zz[i]=EMPTY_VALUE;
               }
            }
         }
      //  
      else
         {
         //   
         if (Low[i]<prev)
            {
            zz[i]=Low[i]; prev=Low[i];
            zz[last]=EMPTY_VALUE; last=i;
            }
         else
            {
            //   
            if (ExtBuffer1[i]>=0+NormalizeDouble(otstup*Point,Digits) )
               {
               bUp=true;
               zz[i]=High[i]; prev=High[i];
               if (ShowPipsValue)
                  {
                  dPipsValue=(High[prevLast]-Low[last])/Point; //     
                  nBarsInZ = prevLast-last; // -   
                  if (HidePippets==true) sData=DoubleToStr(dPipsValue/10,0); else sData=DoubleToStr(dPipsValue,0);
                  if (ShowBarsCount==true)
                  {
                    sData=StringConcatenate(sData," (",nBarsInZ,")");
                  }  
                  id="exm"+prevLast;
                  //     
                  if (ObjectFind(id)==-1)
                     {
                     ObjectCreate(id,OBJ_TEXT,0,Time[last],Low[last]-TextIndentDown*Point);
                     //ObjectSetText(id,sData,FontSize,FontName,FontColor);
                     }
                  ObjectMove(id,0,Time[last],Low[last]-TextIndentDown*Point);
                  ObjectSetText(id,sData,FontSize,FontName,FontColor);
                  }
               prevLast=last; last=i;
               }
            //   
            else
               {
               zz[i]=EMPTY_VALUE;
               }
            }
         }
      }
   return(0);
   }   